/**
 *                                                                            
 *  Copyright (c) 2011, 2016 - Loetz GmbH&Co.KG (69115 Heidelberg, Germany) 
 *                                                                            
 *  All rights reserved. This program and the accompanying materials           
 *  are made available under the terms of the Eclipse Public License 2.0        
 *  which accompanies this distribution, and is available at                  
 *  https://www.eclipse.org/legal/epl-2.0/                                 
 *                                 
 *  SPDX-License-Identifier: EPL-2.0                                 
 *                                                                            
 *  Contributors:                                                      
 * 	   Florian Pirchner - Initial implementation
 * 
 */
package org.eclipse.osbp.ecview.extension.model.converter.provider;

import org.eclipse.osbp.ecview.extension.model.converter.util.YConverterAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class YConverterItemProviderAdapterFactory extends YConverterAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	
	/**
<<<<<<< HEAD
	 * <!-- begin-user-doc --> <!-- end-user-doc -->.
	 *
	 * @generated
	 */
	public static final String copyright = "All rights reserved by Loetz GmbH und CoKG Heidelberg 2015.\n\nContributors:\n      Florian Pirchner - initial API and implementation";

	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public YConverterItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YObjectToStringConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YObjectToStringConverterItemProvider yObjectToStringConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YObjectToStringConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYObjectToStringConverterAdapter() {
		if (yObjectToStringConverterItemProvider == null) {
			yObjectToStringConverterItemProvider = new YObjectToStringConverterItemProvider(this);
		}

		return yObjectToStringConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YStringToByteArrayConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YStringToByteArrayConverterItemProvider yStringToByteArrayConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YStringToByteArrayConverter}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYStringToByteArrayConverterAdapter() {
		if (yStringToByteArrayConverterItemProvider == null) {
			yStringToByteArrayConverterItemProvider = new YStringToByteArrayConverterItemProvider(this);
		}

		return yStringToByteArrayConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YCustomDecimalConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YCustomDecimalConverterItemProvider yCustomDecimalConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YCustomDecimalConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYCustomDecimalConverterAdapter() {
		if (yCustomDecimalConverterItemProvider == null) {
			yCustomDecimalConverterItemProvider = new YCustomDecimalConverterItemProvider(this);
		}

		return yCustomDecimalConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YNumericToResourceConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YNumericToResourceConverterItemProvider yNumericToResourceConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YNumericToResourceConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYNumericToResourceConverterAdapter() {
		if (yNumericToResourceConverterItemProvider == null) {
			yNumericToResourceConverterItemProvider = new YNumericToResourceConverterItemProvider(this);
		}

		return yNumericToResourceConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YStringToResourceConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YStringToResourceConverterItemProvider yStringToResourceConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YStringToResourceConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYStringToResourceConverterAdapter() {
		if (yStringToResourceConverterItemProvider == null) {
			yStringToResourceConverterItemProvider = new YStringToResourceConverterItemProvider(this);
		}

		return yStringToResourceConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YNumericToResourceConfig} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YNumericToResourceConfigItemProvider yNumericToResourceConfigItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YNumericToResourceConfig}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYNumericToResourceConfigAdapter() {
		if (yNumericToResourceConfigItemProvider == null) {
			yNumericToResourceConfigItemProvider = new YNumericToResourceConfigItemProvider(this);
		}

		return yNumericToResourceConfigItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YStringToResourceConfig} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YStringToResourceConfigItemProvider yStringToResourceConfigItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YStringToResourceConfig}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYStringToResourceConfigAdapter() {
		if (yStringToResourceConfigItemProvider == null) {
			yStringToResourceConfigItemProvider = new YStringToResourceConfigItemProvider(this);
		}

		return yStringToResourceConfigItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YPriceToStringConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YPriceToStringConverterItemProvider yPriceToStringConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YPriceToStringConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYPriceToStringConverterAdapter() {
		if (yPriceToStringConverterItemProvider == null) {
			yPriceToStringConverterItemProvider = new YPriceToStringConverterItemProvider(this);
		}

		return yPriceToStringConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YQuantityToStringConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YQuantityToStringConverterItemProvider yQuantityToStringConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YQuantityToStringConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYQuantityToStringConverterAdapter() {
		if (yQuantityToStringConverterItemProvider == null) {
			yQuantityToStringConverterItemProvider = new YQuantityToStringConverterItemProvider(this);
		}

		return yQuantityToStringConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YNumericToUomoConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YNumericToUomoConverterItemProvider yNumericToUomoConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YNumericToUomoConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYNumericToUomoConverterAdapter() {
		if (yNumericToUomoConverterItemProvider == null) {
			yNumericToUomoConverterItemProvider = new YNumericToUomoConverterItemProvider(this);
		}

		return yNumericToUomoConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YDecimalToUomoConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YDecimalToUomoConverterItemProvider yDecimalToUomoConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YDecimalToUomoConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYDecimalToUomoConverterAdapter() {
		if (yDecimalToUomoConverterItemProvider == null) {
			yDecimalToUomoConverterItemProvider = new YDecimalToUomoConverterItemProvider(this);
		}

		return yDecimalToUomoConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YSimpleDecimalConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YSimpleDecimalConverterItemProvider ySimpleDecimalConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YSimpleDecimalConverter}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYSimpleDecimalConverterAdapter() {
		if (ySimpleDecimalConverterItemProvider == null) {
			ySimpleDecimalConverterItemProvider = new YSimpleDecimalConverterItemProvider(this);
		}

		return ySimpleDecimalConverterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.extension.model.converter.YVaaclipseUiThemeToStringConverter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YVaaclipseUiThemeToStringConverterItemProvider yVaaclipseUiThemeToStringConverterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.extension.model.converter.YVaaclipseUiThemeToStringConverter}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYVaaclipseUiThemeToStringConverterAdapter() {
		if (yVaaclipseUiThemeToStringConverterItemProvider == null) {
			yVaaclipseUiThemeToStringConverterItemProvider = new YVaaclipseUiThemeToStringConverterItemProvider(this);
		}

		return yVaaclipseUiThemeToStringConverterItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 *
	 * @return the root adapter factory
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 *
	 * @param parentAdapterFactory
	 *            the new this keeps track of the root adapter factory that
	 *            delegates to this adapter factory
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->.
	 *
	 * @param type
	 *            the type
	 * @return true, if is factory for type
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->.
	 *
	 * @param object
	 *            the object
	 * @param type
	 *            the type
	 * @return the object
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to
	 * {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 *
	 * @param notification
	 *            the notification
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (yObjectToStringConverterItemProvider != null) yObjectToStringConverterItemProvider.dispose();
		if (yStringToByteArrayConverterItemProvider != null) yStringToByteArrayConverterItemProvider.dispose();
		if (yCustomDecimalConverterItemProvider != null) yCustomDecimalConverterItemProvider.dispose();
		if (yNumericToResourceConverterItemProvider != null) yNumericToResourceConverterItemProvider.dispose();
		if (yStringToResourceConverterItemProvider != null) yStringToResourceConverterItemProvider.dispose();
		if (yNumericToResourceConfigItemProvider != null) yNumericToResourceConfigItemProvider.dispose();
		if (yStringToResourceConfigItemProvider != null) yStringToResourceConfigItemProvider.dispose();
		if (yPriceToStringConverterItemProvider != null) yPriceToStringConverterItemProvider.dispose();
		if (yQuantityToStringConverterItemProvider != null) yQuantityToStringConverterItemProvider.dispose();
		if (yNumericToUomoConverterItemProvider != null) yNumericToUomoConverterItemProvider.dispose();
		if (yDecimalToUomoConverterItemProvider != null) yDecimalToUomoConverterItemProvider.dispose();
		if (ySimpleDecimalConverterItemProvider != null) ySimpleDecimalConverterItemProvider.dispose();
		if (yVaaclipseUiThemeToStringConverterItemProvider != null) yVaaclipseUiThemeToStringConverterItemProvider.dispose();
	}

}
